//+------------------------------------------------------------------+
//|                                                    Ispitanie.mq4 |
//|                                                   Ubaydov_Sergey |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Ubaydov_Sergey"
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int       Razn=3;
extern double    StohBuy=40.0;
extern double    Stohsell=60.0;
extern double    Lots=0.1;
double ask_0, bid_0, point;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   point=MarketInfo(NULL,MODE_POINT);
   ask_0=MarketInfo(NULL,MODE_ASK);
   bid_0=MarketInfo(NULL,MODE_BID); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  if(OrdersTotal()>0) ProvClose();
   else     ProvOpen(); 
//----
   return(0);
  }  
//+------------------------------------------------------------------+
//| Check for conditions Close                                            |
//+------------------------------------------------------------------+
void ProvClose()
   {
    OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
     if(OrderType()==OP_BUY) ZakrBuy();
     else                    ZakrSell();
    return;
   } 
//+------------------------------------------------------------------+
//Zakr_buy                                                           |
//+------------------------------------------------------------------+   
void ZakrBuy()
  {
    if(Bid > bid_0+5*point) bid_0=bid_0+4*point;
    else
        if(Bid < bid_0-8*point) 
        bool z=OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
    return;
  } 
//+------------------------------------------------------------------+
//Zakr_sell                                                          |
//+------------------------------------------------------------------+   
void ZakrSell()
   {
    if(Ask<ask_0-point*5) ask_0=ask_0-point*4;                                                                 
    else
      if(Ask>(ask_0+point*8)) 
      bool d=OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
     return;
    }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void ProvOpen()
  {
          double Stoh=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
      if(Stoh>iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,0))     
        {                                                                 
         if(Stoh<StohBuy)                                           
           {                                                        
             if(Ask>(ask_0+Razn*point)) 
              {                                                     
             bool res=OrderSend(NULL,OP_BUY,Lots,Ask,3,Bid-20*point,0,"",,0,Blue);
               print("  BUY");
              };                                                           
             };                                                      
        else 
            {                                                           
            if(Stoh>Stohsell) 
             {                                                         
              if(Bid<(bid_0-Razn*point)) 
             {                                                       
               res=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+20*point,0,"",,0,Red);
               Print("  SELL");
              };                                                       
          };                                                         
     return;                                                             
  }
//+------------------------------------------------------------------+